#include <stdlib.h>
#include <string.h>

#include "kword.h"
#include "parser.h"
#include "lib.h"

struct kword cfg_keyword[] = {
   { "options",  K_OPTIONS }, 
   { "default",  K_DEFAULT },
   { "up",	 K_UP },
   { "down",	 K_DOWN },
   { "psm",      K_PSM }, 
   { "srcaddr",  K_SRCADDR }, 
   { "addr",  	 K_ADDR }, 
   { "iface",  	 K_IFACE }, 
   { "persist",	 K_PERSIST }, 
   { "multi",	 K_MULTI }, 
   { "channel",	 K_CHANNEL }, 
   { "timeout",	 K_TIMEOUT }, 
   { "program",  K_PROG }, 
   { "ppp",	 K_PPP },
   { "ifconfig", K_IFCFG },
   { "ifcfg", 	 K_IFCFG },
   { "firewall", K_FWALL }, 
   { "route", 	 K_ROUTE }, 
   { "stat",	 K_STAT }, 
   { NULL , 0 }
};

struct kword cfg_param[] = {
   { "yes",      1 }, 
   { "no",       0 },
   { "allow",	 1 },
   { "deny",	 0 },
   { "enable",	 1 },
   { "disable",	 0 },
   { "wait",	 CMD_WAIT },
   { "kill",	 RFCOMMD_MULTI_KILL },
   { NULL , 0 }
};

int find_keyword(struct kword *kw, char *str)
{
    while( kw->str ){
	if( !strncmp(str,kw->str,4) )
	   return kw->type;
	kw++;
    }
    return -1;
}
