/* 
	RFCOMMd - RFCOMM daemon.
	Copyright (C) 2001 Qualcomm Incorporated

	Written 2001 by Maxim Krasnyansky <maxk@qualcomm.com>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License version 2 as
	published by the Free Software Foundation;

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY RIGHTS.
	IN NO EVENT SHALL THE COPYRIGHT HOLDER(S) AND AUTHOR(S) BE LIABLE FOR ANY CLAIM,
	OR ANY SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER
	RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
	NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE
	USE OR PERFORMANCE OF THIS SOFTWARE.

	ALL LIABILITY, INCLUDING LIABILITY FOR INFRINGEMENT OF ANY PATENTS, COPYRIGHTS,
	TRADEMARKS OR OTHER RIGHTS, RELATING TO USE OF THIS SOFTWARE IS DISCLAIMED.
*/

/* 
	Based on:
	VTun - Virtual Tunnel over TCP/IP network.
	Copyright (C) 1998-2001 Maxim Krasnyansky <max_mk@yahoo.com>
*/

/*
 * $Id$
 */

#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <syslog.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <errno.h>

#ifdef HAVE_SYS_SOCKIO_H
#include <sys/sockio.h>
#endif

#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif

#ifdef HAVE_NETINET_IN_SYSTM_H
#include <netinet/in_systm.h>
#endif

#ifdef HAVE_NETINET_IP_H
#include <netinet/ip.h>
#endif

#ifdef HAVE_NETINET_TCP_H
#include <netinet/tcp.h>
#endif

#ifdef HAVE_RESOLV_H
#include <resolv.h>
#endif

#ifdef HAVE_ARPA_INET_H
#include <arpa/inet.h>
#endif

#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif

#include <bluetooth/bluetooth.h>
#include <bluetooth/l2cap.h>


#include "rfcommd.h"
#include "lib.h"
#include "netlib.h"

/* Connect with timeout */
int connect_t(int s, struct sockaddr *svr, time_t timeout)
{
	return connect(s,svr,sizeof(struct sockaddr));
	/*
	     int sock_flags;
	     fd_set fdset;
	     struct timeval tv;
	 
	     tv.tv_usec=0; tv.tv_sec=timeout;
	 
	     sock_flags=fcntl(s,F_GETFL);
	     if( fcntl(s,F_SETFL,O_NONBLOCK) < 0 )
	        return -1;
	 
	     if( connect(s,svr,sizeof(struct sockaddr)) < 0 && errno != EINPROGRESS)
	        return -1;
	 
	     FD_ZERO(&fdset);
	     FD_SET(s,&fdset);
	     if( select(s+1,NULL,&fdset,NULL,timeout?&tv:NULL) > 0 ){
	        int l=sizeof(errno);	 
	        errno=0;
	        getsockopt(s,SOL_SOCKET,SO_ERROR,&errno,&l);
	     } else
	        errno=ETIMEDOUT;  	
	 
	     fcntl(s,F_SETFL,sock_flags); 
	 
	     if( errno )
	        return -1;
	 
	     return 0;
	*/
}

/* Get interface address */
bdaddr_t * getifaddr(char * ifname)
{
	/*
	struct sockaddr_in addr;
	struct ifreq ifr;
	int s;

	if( (s = socket(AF_INET, SOCK_DGRAM, 0)) == -1 )
	   return -1;

	strncpy(ifr.ifr_name, ifname, sizeof(ifr.ifr_name)-1);
	ifr.ifr_name[sizeof(ifr.ifr_name)-1]='\0';

	if( ioctl(s, SIOCGIFADDR, &ifr) < 0 ){
	   close(s);
	   return -1;
}
	close(s);

	addr = *((struct sockaddr_in *) &ifr.ifr_addr);
	*/

	return BDADDR_ANY;
}

/* Set local address */
int local_addr(struct sockaddr_l2 *addr, struct session *s)
{
	struct hostent * hent;
	int opt;

	memset(addr, 0, sizeof(struct sockaddr));
	addr->l2_family = AF_BLUETOOTH;
	addr->l2_psm = 0;
	switch( s->src_addr.type )
	{
			/*
			       case RFCOMMD_ADDR_IFACE:
			           if( !( addr->l2_bdaddr = getifaddr(host->src_addr.name)) ){
			              syslog(LOG_ERR,"Can't get address of interface %s", host->src_addr.name);
			              return -1;
			           }
			    break;
			       case RFCOMMD_ADDR_NAME:
			           if( !(hent = gethostbyname(host->src_addr.name)) ){
			              syslog(LOG_ERR,"Can't resolv local address %s", host->src_addr.name);
			              return -1;
			           }
			           addr->l2_bdaddr = *(unsigned long *)hent->h_addr; 
			    break;
			*/
		default:
			bacpy(&addr->l2_bdaddr, BDADDR_ANY);
			break;
	}

	s->sopt.laddr = strdup(batostr(&addr->l2_bdaddr));

	return 0;
}

int server_addr(struct sockaddr_l2 *addr, struct session *s)
{
	struct hostent * hent;

	memset(addr, 0, sizeof(struct sockaddr_l2));
	addr->l2_family = AF_BLUETOOTH;
	addr->l2_psm    = htobs(rfcommd.svr_psm);
	baswap(&addr->l2_bdaddr, strtoba(rfcommd.svr_addr));

	s->sopt.raddr = strdup(rfcommd.svr_addr);
	s->sopt.rpsm = rfcommd.svr_psm;

	return 0;
}
